<template>
  <CModal
    :show.sync="visible"
    :centered="false"
    :close-on-backdrop="false"
    class="modal-form modal-form-2-col"
    @open="$emit('open')"
    @close="$emit('close')"
  >
    <template #header>
      <h6 class="modal-title">
        <font-awesome-icon :icon="['fas', `${id ? 'pencil-alt' : 'plus-circle'}`]" />
        {{ id ? EDIT_LABEL : ADD_LABEL }}
      </h6>
      <CButtonClose @click="onCancel" />
    </template>

    <thing-form
      :id="id"
      @close="onCancel"
      @modify="$emit('modify')"
    />

    <template #footer>
      <span />
    </template>
  </CModal>
</template>

<script>
import ThingForm from './ThingForm'

const EDIT_LABEL = 'Edit thing'
const ADD_LABEL = 'Add new thing'
export default {
  components: {
    ThingForm
  },

  props: {
    /**
     * User id
     */
    id: {
      type: Number,
      default: 0
    }
  },

  data () {
    return {
      visible: false,
      EDIT_LABEL,
      ADD_LABEL
    }
  },

  methods: {
    /**
     * Open dialog
     */
    open () {
      this.visible = true
    },

    /**
     * When you click Cancel button
     */
    onCancel () {
      this.visible = false
    }
  }
}
</script>
